Index: /extensions/oAuth/admin/providers.php
===================================================================
--- /extensions/oAuth/admin/providers.php	(revision 26607)
+++ /extensions/oAuth/admin/providers.php	(revision 26608)
@@ -58,5 +58,6 @@
   'PROVIDERS' => $PROVIDERS_CONFIG,
   'CONFIG' => $hybridauth_conf['providers'],
-  'SERVERNAME' => get_absolute_root_url(),
+  'SERVERNAME' => get_servername(),
+  'WEBSITE' => get_absolute_root_url(),
   'OAUTH_CALLBACK' => OAUTH_PUBLIC . '?hauth.done=',
   ));
Index: /extensions/oAuth/admin/template/providers.tpl
===================================================================
--- /extensions/oAuth/admin/template/providers.tpl	(revision 26607)
+++ /extensions/oAuth/admin/template/providers.tpl	(revision 26608)
@@ -101,23 +101,23 @@
       
       {if $p=='Live'}
-        <li>{'Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'|translate|sprintf:'<b>Redirect Domain</b>':$SERVERNAME}</li>
+        <li>{'Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'|translate|sprintf:'<b>Redirect Domain</b>':$WEBSITE}</li>
       {elseif $p=='Facebook'}
-        <li>{'Go to <b>Settings->Advanced</b> and activate <em>Client OAuth Login</em>.'|translate}</li>
+        <li>{'Go to <b>Settings->Advanced</b> and activate <em>Client OAuth Login</em>'|translate}</li>
         <li>{'Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'|translate|sprintf:'<b>Valid OAuth redirect URIs</b>':$SERVERNAME}</li>
       {elseif $p=='LinkedIn'}
-        <li>{'Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'|translate|sprintf:'<b>Website URL</b>':$SERVERNAME}</li>
+        <li>{'Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'|translate|sprintf:'<b>Website URL</b>':$WEBSITE}</li>
         <li>{'Set <b>%s</b> to <em>%s</em>'|translate|sprintf:'Application Type':'Web Application'}</li>
         <li>{'Set <b>%s</b> to <em>%s</em>'|translate|sprintf:'Default Scope':'r_basicprofile & r_emailaddress'}</li>
       {elseif $p=='Yahoo'}
-        <li>{'Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'|translate|sprintf:'<b>Application URL</b>, <b>Application Domain</b>':$SERVERNAME}</li>
+        <li>{'Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'|translate|sprintf:'<b>Application URL</b>, <b>Application Domain</b>':$WEBSITE}</li>
         <li>{'Set <b>%s</b> to <em>%s</em>'|translate|sprintf:'Kind of Application':'Web-based'}</li>
         <li>{'Set <b>%s</b> to <em>%s</em>'|translate|sprintf:'Access Scopes':'This app will only access public...'}</li>
         <li>{'Once the application is registered update the permissions : set <b>Contacts</b> as <em>Read</em> and <b>Social Directory</b> as <em>Read Public</em>'|translate}</li>
       {elseif $p=='Twitter'}
-        <li>{'Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'|translate|sprintf:'<b>Website</b>, <b>Callback URL</b>':$SERVERNAME}</li>
+        <li>{'Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'|translate|sprintf:'<b>Website</b>':$WEBSITE}</li>
       {elseif $p=='Tumblr'}
-        <li>{'Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'|translate|sprintf:'<b>Application Website</b>, <b>Default Callback URL</b>':$SERVERNAME}</li>
+        <li>{'Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'|translate|sprintf:'<b>Application Website</b>':$WEBSITE}</li>
       {elseif $p=='Instagram'}
-        <li>{'Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'|translate|sprintf:'<b>Website</b>':$SERVERNAME}</li>
+        <li>{'Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'|translate|sprintf:'<b>Website</b>':$WEBSITE}</li>
       {elseif $p=='Google'}
         <li>{'Set <b>%s</b> to <em>%s</em>'|translate|sprintf:'Application Type':'Web Application'}</li>
@@ -130,7 +130,7 @@
       <p style="text-align:left;">
       {if $p=='Flickr' or $p=='Steam' or $p=='Wordpress'}
-        {'Based on OpenID.'|translate}</br>
+        {'Based on OpenID'|translate}</br>
       {/if}
-      {'No registration required.'|translate}<br>
+      {'No registration required'|translate}<br>
       <a href="{$provider.about_link}" target="_blank">{'About'|translate}</a>
       </p>
Index: /extensions/oAuth/auth.php
===================================================================
--- /extensions/oAuth/auth.php	(revision 26607)
+++ /extensions/oAuth/auth.php	(revision 26608)
@@ -4,4 +4,8 @@
 
 global $hybridauth_conf;
+
+// OpenID is always enabled
+$hybridauth_conf['providers']['OpenID']['enabled'] = true;
+
 require_once(OAUTH_PATH . 'include/hybridauth/Hybrid/Auth.php');
 
@@ -9,13 +13,4 @@
 
 try {
-  // inputs
-  if ($provider == 'OpenID' and !isset($_GET['openid_identifier']))
-  {
-    throw new Exception('Invalid OpenID!', 1003);
-  }
-  
-  // OpenID is always enabled
-  $hybridauth_conf['providers']['OpenID']['enabled'] = true;
-  
   if (!array_key_exists($provider, $hybridauth_conf['providers'])
       or !$hybridauth_conf['providers'][$provider]['enabled']
@@ -27,4 +22,10 @@
   if ($provider == 'Persona')
   {
+    if (!verify_ephemeral_key(@$_POST['key']) | empty($_POST['assertion']))
+    {
+      header('HTTP/1.1 403 Forbidden');
+      exit;
+    }
+    
     $response = persona_verify($_POST['assertion']);
     
@@ -41,7 +42,11 @@
   else
   {
+    if ($provider == 'OpenID' and empty($_GET['openid_identifier']))
+    {
+      throw new Exception('Invalid OpenID!', 1003);
+    }
+    
     $hybridauth = new Hybrid_Auth($hybridauth_conf);
     
-    // connected
     if ($hybridauth->isConnectedWith($provider))
     {
@@ -53,4 +58,5 @@
   }
   
+  // connected
   if (!empty($oauth_id))
   {
@@ -61,4 +67,5 @@
 ;';
     $result = pwg_query($query);
+
     // registered : log_user and redirect
     if (pwg_db_num_rows($result))
@@ -111,4 +118,9 @@
   else
   {
+    if (!verify_ephemeral_key(@$_GET['key']))
+    {
+      throw new Exception('Forbidden', 403);
+    }
+    
     $template->assign('LOADING', '&openid_identifier='.@$_GET['openid_identifier'].'&init_auth=1');
   }
@@ -125,4 +137,5 @@
    404 : User not found
  other errors :
+   403 : Invalid ephemeral key
    503 : Persona error
   1002 : Invalid provider
@@ -149,5 +162,5 @@
   
   'OAUTH_PATH' => OAUTH_PATH,
-  'PROVIDER' => $provider,
+  'PROVIDER' => $hybridauth_conf['providers'][$provider]['name'],
   'SELF_URL' => OAUTH_PATH . 'auth.php?provider='.$provider,
   ));
Index: /extensions/oAuth/include/functions.inc.php
===================================================================
--- /extensions/oAuth/include/functions.inc.php	(revision 26607)
+++ /extensions/oAuth/include/functions.inc.php	(revision 26608)
@@ -45,4 +45,5 @@
       'providers' => $hybridauth_conf['providers'],
       'persona_email' => @$persona_email,
+      'key' => get_ephemeral_key(0),
       ));
     $template->assign(array(
@@ -81,4 +82,21 @@
 }
 
+function get_servername($with_port=false)
+{
+  $scheme = 'http';
+  if ( (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off') || $_SERVER['SERVER_PORT'] == 443 )
+  {
+    $scheme = 'https';
+  }
+  
+  $servername = $scheme . '://' . $_SERVER['HTTP_HOST'];
+  if ($with_port)
+  {
+    $servername.= ':' . $_SERVER['SERVER_PORT'];
+  }
+    
+  return $servername;
+}
+
 // http://www.sitepoint.com/authenticate-users-with-mozilla-persona/
 function persona_verify()
@@ -93,17 +111,5 @@
     );
 
-  $scheme = 'http';
-  if ( (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off') || $_SERVER['SERVER_PORT'] == 443 )
-  {
-    $scheme = 'https';
-  }
-  $audience = sprintf(
-    '%s://%s:%s',
-    $scheme,
-    $_SERVER['HTTP_HOST'],
-    $_SERVER['SERVER_PORT']
-    );
-
-  $params = 'assertion=' . urlencode($assert) . '&audience=' . urlencode($audience);
+  $params = 'assertion=' . urlencode($assert) . '&audience=' . urlencode(get_servername(true));
 
   $options = array(
Index: /extensions/oAuth/include/providers_stats.inc.php
===================================================================
--- /extensions/oAuth/include/providers_stats.inc.php	(revision 26607)
+++ /extensions/oAuth/include/providers_stats.inc.php	(revision 26608)
@@ -33,4 +33,5 @@
     'label'             => 'Tumblr',
     'provider_name'     => 'Tumblr',
+    'callback'          => true,
     'new_app_link'      => 'http://www.tumblr.com/oauth/apps',
   ),
@@ -38,4 +39,5 @@
     'label'             => 'Twitter',
     'provider_name'     => 'Twitter',
+    'callback'          => true,
     'new_app_link'      => 'https://dev.twitter.com/apps',
   ),
Index: /extensions/oAuth/include/public_events.inc.php
===================================================================
--- /extensions/oAuth/include/public_events.inc.php	(revision 26607)
+++ /extensions/oAuth/include/public_events.inc.php	(revision 26608)
@@ -69,5 +69,5 @@
       {
         $template->assign('OAUTH_USER', array(
-          'provider' => $provider,
+          'provider' => 'Persona',
           'username' => $user_identifier,
           'u_profile' => null,
@@ -96,5 +96,5 @@
       
         $template->assign('OAUTH_USER', array(
-          'provider' => $provider,
+          'provider' => $hybridauth_conf['providers'][$provider]['name'],
           'username' => $remote_user->displayName,
           'u_profile' => $remote_user->profileURL,
@@ -191,5 +191,5 @@
     {
       $template->assign('OAUTH_USER', array(
-        'provider' => $provider,
+        'provider' => 'Persona',
         'username' => $user_identifier,
         'u_profile' => null,
@@ -206,5 +206,5 @@
       
       $template->assign('OAUTH_USER', array(
-        'provider' => $provider,
+        'provider' => $hybridauth_conf['providers'][$provider]['name'],
         'username' => $remote_user->displayName,
         'u_profile' => $remote_user->profileURL,
Index: /extensions/oAuth/language/bg_BG/help.lang.php
===================================================================
--- /extensions/oAuth/language/bg_BG/help.lang.php	(revision 26607)
+++ /extensions/oAuth/language/bg_BG/help.lang.php	(revision 26608)
@@ -22,5 +22,5 @@
 // +-----------------------------------------------------------------------+
 $lang['Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'] = 'Сложете си домейна на уебсайта в областите на компетентност на%s. Той трябва да съвпада с името на хоста: <em>%s</em>';
-$lang['Set the <b>%s</b> to <em>%s</em>'] = 'Задайте<b>%s</b>за да<em>%s</em>';
+$lang['Set <b>%s</b> to <em>%s</em>'] = 'Задайте<b>%s</b>за да<em>%s</em>';
 $lang['Provide this URL as the Callback/Redirect URL for your application: <em>%s</em>'] = 'Осигуряване на този адрес, като Callback / URL адрес за пренасочване за вашето приложение: <em>%s</em>';
 $lang['Once you have registered, copy and past the created application credentials into this setup page'] = 'След като сте се регистрирали, копирате и поставите създадени пълномощията за кандидатстване в тази настройка страница';
Index: /extensions/oAuth/language/da_DK/help.lang.php
===================================================================
--- /extensions/oAuth/language/da_DK/help.lang.php	(revision 26607)
+++ /extensions/oAuth/language/da_DK/help.lang.php	(revision 26608)
@@ -27,5 +27,5 @@
 $lang['Provide this URL as the Callback/Redirect URL for your application: <em>%s</em>'] = 'Denne URL benyttes som din applikations tilbagekalds-/viderestillings-URL (Callback/Redirect): <em>%s</em>';
 $lang['Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'] = 'Skriv din hjemmesides domæne i %s-felterne. Det skal svare til det aktuelle værtsnavn: <em>%s</em>';
-$lang['Set the <b>%s</b> to <em>%s</em>'] = 'Opsæt <b>%s</b> til <em>%s</em>';
+$lang['Set <b>%s</b> to <em>%s</em>'] = 'Opsæt <b>%s</b> til <em>%s</em>';
 $lang['Fill out any required fields such as the application name and description'] = 'Udfyld krævede felter så som applikationsnavn og beskrivelse';
 $lang['Go to <a href="%s" target="_blank">%s</a> and create a new application'] = 'Gå til <a href="%s" target="_blank">%s</a> og opret en ny applikation';
Index: /extensions/oAuth/language/de_DE/help.lang.php
===================================================================
--- /extensions/oAuth/language/de_DE/help.lang.php	(revision 26607)
+++ /extensions/oAuth/language/de_DE/help.lang.php	(revision 26608)
@@ -24,5 +24,5 @@
 $lang['Provide this URL as the Callback/Redirect URL for your application: <em>%s</em>'] = 'Verwende diese URL als Callback/Redirect URL deiner Applikation <em>%s</em>';
 $lang['Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'] = 'Setze deine Webseiten-Domain in die %s Felder. Diese sollte identisch sein mit dem Hostnamen:  <em>%s</em>';
-$lang['Set the <b>%s</b> to <em>%s</em>'] = 'Setze den <b>%s</b> auf <em>%s</em>';
+$lang['Set <b>%s</b> to <em>%s</em>'] = 'Setze den <b>%s</b> auf <em>%s</em>';
 $lang['Fill out any required fields such as the application name and description'] = 'Fülle alle notwendigen Felder wie den Applikations-Namen und Beschreibung aus.';
 $lang['Go to <a href="%s" target="_blank">%s</a> and create a new application'] = 'Gehe zu <a href="%s" target="_blank">%s</a> und erstelle eine neue Applikation';
Index: /extensions/oAuth/language/el_GR/help.lang.php
===================================================================
--- /extensions/oAuth/language/el_GR/help.lang.php	(revision 26607)
+++ /extensions/oAuth/language/el_GR/help.lang.php	(revision 26608)
@@ -35,4 +35,4 @@
 $lang['Go to <a href="%s" target="_blank">%s</a> and create a new application'] = 'Μετάβαση στο <a href="%s" target="_blank">%s</a> και δημιουργήστε μια νέα εφαρμογή';
 $lang['Fill out any required fields such as the application name and description'] = 'Συμπληρώστε όλα τα απαιτούμενα πεδία, όπως το όνομα της εφαρμογής και περιγραφή';
-$lang['Set the <b>%s</b> to <em>%s</em>'] = 'Ρυθμίστε το <b>%s</b> σε <em>%s</em>';
+$lang['Set <b>%s</b> to <em>%s</em>'] = 'Ρυθμίστε το <b>%s</b> σε <em>%s</em>';
 ?>
Index: /extensions/oAuth/language/en_UK/help.lang.php
===================================================================
--- /extensions/oAuth/language/en_UK/help.lang.php	(revision 26607)
+++ /extensions/oAuth/language/en_UK/help.lang.php	(revision 26608)
@@ -1,14 +1,15 @@
 <?php
 
+$lang['Based on OpenID'] = 'Based on OpenID';
 $lang['Go to <a href="%s" target="_blank">%s</a> and create a new application'] = 'Go to <a href="%s" target="_blank">%s</a> and create a new application';
-$lang['On the <b>API Access</b> tab, <b>create an OAuth 2.0 Client ID</b>'] = 'On the <b>API Access</b> tab, <b>create an OAuth 2.0 Client ID</b>';
-$lang['On the <b>Create Client ID</b> popup, switch to advanced settings by clicking on <b>(more options)</b>'] = 'On the <b>Create Client ID</b> popup, switch to advanced settings by clicking on <b>(more options)</b>';
+$lang['On the <b>APIs & auth -> Credentials</b> tab, <b>Create new client ID</b>'] = 'On the <b>APIs & auth -> Credentials</b> tab, <b>Create new client ID</b>';
 $lang['Fill out any required fields such as the application name and description'] = 'Fill out any required fields such as the application name and description';
 $lang['Provide this URL as the Callback/Redirect URL for your application: <em>%s</em>'] = 'Provide this URL as the Callback/Redirect URL for your application: <em>%s</em>';
 $lang['Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'] = 'Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>';
-$lang['Set the <b>%s</b> to <em>%s</em>'] = 'Set the <b>%s</b> to <em>%s</em>';
+$lang['Set <b>%s</b> to <em>%s</em>'] = 'Set <b>%s</b> to <em>%s</em>';
 $lang['Once you have registered, copy and past the created application credentials into this setup page'] = 'Once you have registered, copy and past the created application credentials into this setup page';
-$lang['No registration required for OpenID based providers'] = 'No registration required for OpenID based providers';
+$lang['No registration required'] = 'No registration required';
 $lang['Once the application is registered update the permissions : set <b>Contacts</b> as <em>Read</em> and <b>Social Directory</b> as <em>Read Public</em>'] = 'Once the application is registered update the permissions : set <b>Contacts</b> as <em>Read</em> and <b>Social Directory</b> as <em>Read Public</em>';
+$lang['Go to <b>Settings->Advanced</b> and activate <em>Client OAuth Login</em>'] = 'Go to <b>Settings->Advanced</b> and activate <em>Client OAuth Login</em>';
 
 ?>
Index: /extensions/oAuth/language/en_UK/plugin.lang.php
===================================================================
--- /extensions/oAuth/language/en_UK/plugin.lang.php	(revision 26607)
+++ /extensions/oAuth/language/en_UK/plugin.lang.php	(revision 26608)
@@ -2,5 +2,4 @@
 
 $lang['%s: invalid keys'] = '%s: invalid keys';
-$lang['OpenID must be enabled in order to use %s authentication'] = 'OpenID must be enabled in order to use %s authentication';
 $lang['Users are not allowed to register on your gallery. Social Connect will not work correctly.'] = 'Users are not allowed to register on your gallery. Social Connect will not work correctly.';
 $lang['Providers'] = 'Providers';
@@ -24,7 +23,9 @@
 $lang['Please enter your OpenID URL'] = 'Please enter your OpenID URL';
 $lang['Please enter your username'] = 'Please enter your username';
+$lang['Please enter your user ID'] = 'Please enter your user ID';
 $lang['Or sign in with'] = 'Or sign in with';
 $lang['Logged with'] = 'Logged with';
 $lang['Profile URL'] = 'Profile URL';
+$lang['Cancel'] = 'Cancel';
 
 ?>
Index: /extensions/oAuth/language/es_ES/help.lang.php
===================================================================
--- /extensions/oAuth/language/es_ES/help.lang.php	(revision 26607)
+++ /extensions/oAuth/language/es_ES/help.lang.php	(revision 26608)
@@ -26,5 +26,5 @@
 $lang['Provide this URL as the Callback/Redirect URL for your application: <em>%s</em>'] = 'Dar esta URL como  Callback/Redirect URL para su aplicación';
 $lang['Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'] = 'Ponga su nombre de dominio en los campos %s. Debe corresponder a <em>%s</em>';
-$lang['Set the <b>%s</b> to <em>%s</em>'] = 'Seleccionar <b>%s</b> para <em>%s</em>';
+$lang['Set <b>%s</b> to <em>%s</em>'] = 'Seleccionar <b>%s</b> para <em>%s</em>';
 $lang['On the <b>API Access</b> tab, <b>create an OAuth 2.0 Client ID</b>'] = 'En la pestaña <b>API Access</b>, hagan clic en <b>create an OAuth 2.0 Client ID</b>';
 $lang['No registration required for OpenID based providers'] = 'No es necesario registrarse para tipos de autenticación OpenID';
Index: /extensions/oAuth/language/et_EE/help.lang.php
===================================================================
--- /extensions/oAuth/language/et_EE/help.lang.php	(revision 26607)
+++ /extensions/oAuth/language/et_EE/help.lang.php	(revision 26608)
@@ -21,5 +21,5 @@
 // | USA.                                                                  |
 // +-----------------------------------------------------------------------+
-$lang['Set the <b>%s</b> to <em>%s</em>'] = 'Seadista <b>%s</b> järgmiseks <em>%s</em>';
+$lang['Set <b>%s</b> to <em>%s</em>'] = 'Seadista <b>%s</b> järgmiseks <em>%s</em>';
 $lang['Provide this URL as the Callback/Redirect URL for your application: <em>%s</em>'] = 'Paku seda URL\'i ümbersuunamiseks sinu aplikatsioonile: <em>%s</em>';
 $lang['Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'] = 'Pane oma veebilehe domeen %s väljale. See peab olema sama mis praegune hosti nimi: <em>%s</em>';
Index: /extensions/oAuth/language/fr_FR/help.lang.php
===================================================================
--- /extensions/oAuth/language/fr_FR/help.lang.php	(revision 26607)
+++ /extensions/oAuth/language/fr_FR/help.lang.php	(revision 26608)
@@ -7,5 +7,5 @@
 $lang['Provide this URL as the Callback/Redirect URL for your application: <em>%s</em>'] = 'Donnez cette URL comme Callback/Redirect URL pour votre application : <em>%s</em>';
 $lang['Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'] = 'Mettez votre nom de domaine dans les champs %s. Il doit correspondre à <em>%s</em>';
-$lang['Set the <b>%s</b> to <em>%s</em>'] = 'Sélectionnez <em>%2$s</em> pour <b>%1$s</b>';
+$lang['Set <b>%s</b> to <em>%s</em>'] = 'Sélectionnez <em>%2$s</em> pour <b>%1$s</b>';
 $lang['Once you have registered, copy and past the created application credentials into this setup page'] = 'Quand votre application est enregistrée, copiez-collez les clefs d\'authentification sur cette page';
 $lang['No registration required for OpenID based providers'] = 'Pas d\'inscription nécessaire pour les authentifications type OpenID';
Index: /extensions/oAuth/language/it_IT/help.lang.php
===================================================================
--- /extensions/oAuth/language/it_IT/help.lang.php	(revision 26607)
+++ /extensions/oAuth/language/it_IT/help.lang.php	(revision 26608)
@@ -23,5 +23,5 @@
 $lang['On the <b>API Access</b> tab, <b>create an OAuth 2.0 Client ID</b>'] = 'Sulla scheda <b>API Access</b>, <b>creare un OAuth 2.0 Client ID</b>';
 $lang['Once the application is registered update the permissions : set <b>Contacts</b> as <em>Read</em> and <b>Social Directory</b> as <em>Read Public</em>'] = 'Una volta che l\'applicazione è registrata aggiornare le autorizzazioni: impostare <b>Contacts</b> come <em>Read</em> e <b>Social Directory</b> come <em>Read Public</em>';
-$lang['Set the <b>%s</b> to <em>%s</em>'] = 'Impostare il <b>%s</b> per <em>%s</em>';
+$lang['Set <b>%s</b> to <em>%s</em>'] = 'Impostare il <b>%s</b> per <em>%s</em>';
 $lang['Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'] = 'Metti il ​​tuo dominio del sito web nei campi del %s. Esso deve corrispondere con l\'attuale hostname: <em>%s</em>';
 $lang['Provide this URL as the Callback/Redirect URL for your application: <em>%s</em>'] = 'Fornisci questo URL come Callback/Redirect URL per l\'applicazione:
Index: /extensions/oAuth/language/lv_LV/help.lang.php
===================================================================
--- /extensions/oAuth/language/lv_LV/help.lang.php	(revision 26607)
+++ /extensions/oAuth/language/lv_LV/help.lang.php	(revision 26608)
@@ -26,5 +26,5 @@
 $lang['Provide this URL as the Callback/Redirect URL for your application: <em>%s</em>'] = 'Piestādiet šo URL kā jūsu aplikācijas Atbildes/Pāradresācijas URL: <em>%s</em>';
 $lang['Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'] = 'Ievietojiet savu vietnes domēnu %s laukos. Tam jāsakrīt ar esošo hosta nosaukumu: <em>%s</em>';
-$lang['Set the <b>%s</b> to <em>%s</em>'] = 'Iestatiet <b>%s</b> stāvoklī <em>%s</em>';
+$lang['Set <b>%s</b> to <em>%s</em>'] = 'Iestatiet <b>%s</b> stāvoklī <em>%s</em>';
 $lang['On the <b>Create Client ID</b> popup, switch to advanced settings by clicking on <b>(more options)</b>'] = '<b>Create Client ID</b> uzlecošā logā, klikšķinot uz <b>(more options)</b>, pārslēdzaties uz papildus iestatījumiem';
 $lang['On the <b>API Access</b> tab, <b>create an OAuth 2.0 Client ID</b>'] = 'Ar <b>API Access</b> tabu, <b>izveidojiet OAuth 2.0 Client ID</b>';
Index: /extensions/oAuth/language/nl_NL/help.lang.php
===================================================================
--- /extensions/oAuth/language/nl_NL/help.lang.php	(revision 26607)
+++ /extensions/oAuth/language/nl_NL/help.lang.php	(revision 26608)
@@ -30,4 +30,4 @@
 $lang['No registration required for OpenID based providers'] = 'Geen registratie verplicht voor OpenID gebaseerde bronnen';
 $lang['On the <b>API Access</b> tab, <b>create an OAuth 2.0 Client ID</b>'] = 'Op de <b>API Access</b> tab, <b>maak een OAuth 2.0 Client ID</b>';
-$lang['Set the <b>%s</b> to <em>%s</em>'] = 'Zet de <b>%s</b> naar <em>%s</em>';
+$lang['Set <b>%s</b> to <em>%s</em>'] = 'Zet de <b>%s</b> naar <em>%s</em>';
 ?>
Index: /extensions/oAuth/language/pl_PL/help.lang.php
===================================================================
--- /extensions/oAuth/language/pl_PL/help.lang.php	(revision 26607)
+++ /extensions/oAuth/language/pl_PL/help.lang.php	(revision 26608)
@@ -23,5 +23,5 @@
 $lang['Provide this URL as the Callback/Redirect URL for your application: <em>%s</em>'] = 'Wprowadź ten adres jako Callback/Redirect ULR dla swojej aplikacji: <em>%s</em>';
 $lang['No registration required for OpenID based providers'] = 'Dla dostawców wspierających OpenID rejestracja nie jest wymagana';
-$lang['Set the <b>%s</b> to <em>%s</em>'] = 'Ustaw <b>%s</b> do <em>%s</em>';
+$lang['Set <b>%s</b> to <em>%s</em>'] = 'Ustaw <b>%s</b> do <em>%s</em>';
 $lang['On the <b>Create Client ID</b> popup, switch to advanced settings by clicking on <b>(more options)</b>'] = 'W okienku <b>Stwórz ID klienta</b>/<b>Create Client ID</b> przejdź do ustawień zaawansowanych klikając <b>(więcej opcji)</b>/<b>(more options)</b>';
 $lang['Once the application is registered update the permissions : set <b>Contacts</b> as <em>Read</em> and <b>Social Directory</b> as <em>Read Public</em>'] = 'Gdy aplikacji zostanie zarejestrowana, zaktualizuj zezwolenia: ustaw <b>Kontakty</b>/<b>Contacts</b> na <em>Odczyt</em>/<em>Odczyt</em> i <b>Katalog społecznościowy</b>/<b>Social Directory</b> na <em>Odczyt publiczny</em>/<em>Read Public</em>';
Index: /extensions/oAuth/language/pt_BR/help.lang.php
===================================================================
--- /extensions/oAuth/language/pt_BR/help.lang.php	(revision 26607)
+++ /extensions/oAuth/language/pt_BR/help.lang.php	(revision 26608)
@@ -27,5 +27,5 @@
 $lang['Provide this URL as the Callback/Redirect URL for your application: <em>%s</em>'] = 'Fornecer essa URL como URL de retorno/redirecionamento para sua aplicação: <em>%s</em>';
 $lang['Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'] = 'Coloque o seu domínio do site nos campos %s. Ele deve combinar com o nome da máquina atual: <em>%s</em>';
-$lang['Set the <b>%s</b> to <em>%s</em>'] = 'Defina o <b>%s</b> para <em>%s</ em>';
+$lang['Set <b>%s</b> to <em>%s</em>'] = 'Defina o <b>%s</b> para <em>%s</ em>';
 $lang['Fill out any required fields such as the application name and description'] = 'Preencha todos os campos necessários, tais como o nome do aplicativo e descrição';
 $lang['Go to <a href="%s" target="_blank">%s</a> and create a new application'] = 'Ir para <a href="%s"target="_blank">%s</a> e criar uma nova aplicação';
Index: /extensions/oAuth/language/pt_PT/help.lang.php
===================================================================
--- /extensions/oAuth/language/pt_PT/help.lang.php	(revision 26607)
+++ /extensions/oAuth/language/pt_PT/help.lang.php	(revision 26608)
@@ -30,4 +30,4 @@
 $lang['Provide this URL as the Callback/Redirect URL for your application: <em>%s</em>'] = 'Forneça este URL como o URL Callback/Redirect para a sua aplicação: <em>%s</em>';
 $lang['Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'] = 'Coloque o domínio do seu website no campos %s. Deverá ser igual ao seu anfitrião actual:<em>%s</em>';
-$lang['Set the <b>%s</b> to <em>%s</em>'] = 'Altere o <b>%s</b> para <em>%s</em>';
+$lang['Set <b>%s</b> to <em>%s</em>'] = 'Altere o <b>%s</b> para <em>%s</em>';
 ?>
Index: /extensions/oAuth/language/ru_RU/help.lang.php
===================================================================
--- /extensions/oAuth/language/ru_RU/help.lang.php	(revision 26607)
+++ /extensions/oAuth/language/ru_RU/help.lang.php	(revision 26608)
@@ -30,4 +30,4 @@
 $lang['Provide this URL as the Callback/Redirect URL for your application: <em>%s</em>'] = 'Укажите этот URL как Callback/Redirect URL для Вашего приложения: <em>%s</em>';
 $lang['Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'] = 'Введите домен Вашего веб-сайта в поле %s. Он должен совпадать с текущим именем хоста: <em>%s</em>';
-$lang['Set the <b>%s</b> to <em>%s</em>'] = 'Введите в поле <b>%s</b> значение <em>%s</em>';
+$lang['Set <b>%s</b> to <em>%s</em>'] = 'Введите в поле <b>%s</b> значение <em>%s</em>';
 ?>
Index: /extensions/oAuth/language/sk_SK/help.lang.php
===================================================================
--- /extensions/oAuth/language/sk_SK/help.lang.php	(revision 26607)
+++ /extensions/oAuth/language/sk_SK/help.lang.php	(revision 26608)
@@ -21,5 +21,5 @@
 // | USA.                                                                  |
 // +-----------------------------------------------------------------------+
-$lang['Set the <b>%s</b> to <em>%s</em>'] = 'Nastaviť <b>%s</b> do <em>%s</em>';
+$lang['Set <b>%s</b> to <em>%s</em>'] = 'Nastaviť <b>%s</b> do <em>%s</em>';
 $lang['Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'] = 'Dať Vašu doménu webstránky do poľa %s';
 $lang['Provide this URL as the Callback/Redirect URL for your application: <em>%s</em>'] = 'Poskytnutie tejto URL ako Callback/Redirect URL pre Vašu aplikáciu: <em>%s</em>';
Index: /extensions/oAuth/language/tr_TR/help.lang.php
===================================================================
--- /extensions/oAuth/language/tr_TR/help.lang.php	(revision 26607)
+++ /extensions/oAuth/language/tr_TR/help.lang.php	(revision 26608)
@@ -23,5 +23,5 @@
 $lang['On the <b>API Access</b> tab, <b>create an OAuth 2.0 Client ID</b>'] = '<b>OAuth 2.0 Client ID</b> sini <b>API Access</b> bölümünden oluşturun';
 $lang['Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'] = 'Web site adresinizi %s yazınız. Geçerli alan adı ile eşleşmesi gerekir. <em>%s</em>';
-$lang['Set the <b>%s</b> to <em>%s</em>'] = '<b>%s</b> olarak <em>%s</em> seçiniz';
+$lang['Set <b>%s</b> to <em>%s</em>'] = '<b>%s</b> olarak <em>%s</em> seçiniz';
 $lang['No registration required for OpenID based providers'] = 'OpenID tabanlı sağlayıcılar için kayıt olmaya gerek yok';
 $lang['Fill out any required fields such as the application name and description'] = 'Uygulama adı ve açıklaması için tüm gerekli alanları doldurun';
Index: /extensions/oAuth/language/uk_UA/help.lang.php
===================================================================
--- /extensions/oAuth/language/uk_UA/help.lang.php	(revision 26607)
+++ /extensions/oAuth/language/uk_UA/help.lang.php	(revision 26608)
@@ -22,4 +22,4 @@
 // +-----------------------------------------------------------------------+
 $lang['Fill out any required fields such as the application name and description'] = 'Заповніть всі необхідні поля, такі як ім’я та опис програми';
-$lang['Set the <b>%s</b> to <em>%s</em>'] = 'Встановіть <b>%s</b> з <em>%s</em>';
+$lang['Set <b>%s</b> to <em>%s</em>'] = 'Встановіть <b>%s</b> з <em>%s</em>';
 ?>
Index: /extensions/oAuth/language/zh_CN/help.lang.php
===================================================================
--- /extensions/oAuth/language/zh_CN/help.lang.php	(revision 26607)
+++ /extensions/oAuth/language/zh_CN/help.lang.php	(revision 26608)
@@ -30,4 +30,4 @@
 $lang['Provide this URL as the Callback/Redirect URL for your application: <em>%s</em>'] = '将此链接作为你的应用的反馈/重定向链接：<em>%s</em>';
 $lang['Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'] = '将你的网站域名填入%s字段。域名应匹配当前主机名：<em>%s</em>';
-$lang['Set the <b>%s</b> to <em>%s</em>'] = '把<b>%s</b>设为<em>%s</em>';
+$lang['Set <b>%s</b> to <em>%s</em>'] = '把<b>%s</b>设为<em>%s</em>';
 ?>
Index: /extensions/oAuth/language/zh_TW/help.lang.php
===================================================================
--- /extensions/oAuth/language/zh_TW/help.lang.php	(revision 26607)
+++ /extensions/oAuth/language/zh_TW/help.lang.php	(revision 26608)
@@ -30,4 +30,4 @@
 $lang['Provide this URL as the Callback/Redirect URL for your application: <em>%s</em>'] = '為您的應用程序提供URL的回呼/重定向URL: <em>%s</em>';
 $lang['Put your website domain in the %s fields. It should match with the current hostname: <em>%s</em>'] = '把你的網站域名，放在 %s 欄位。它應該匹配目前的主機名稱： <em>%s</em>';
-$lang['Set the <b>%s</b> to <em>%s</em>'] = '設定 <b>%s</b> 到 <em>%s</em>';
+$lang['Set <b>%s</b> to <em>%s</em>'] = '設定 <b>%s</b> 到 <em>%s</em>';
 ?>
Index: /extensions/oAuth/template/identification_common.tpl
===================================================================
--- /extensions/oAuth/template/identification_common.tpl	(revision 26607)
+++ /extensions/oAuth/template/identification_common.tpl	(revision 26608)
@@ -28,5 +28,5 @@
 function open_auth(url) {
   window.open(
-    url + '&t=' + (new Date()).getTime(), 
+    '{$OAUTH.u_login}' + url + '&key={$OAUTH.key}', 
     'hybridauth_social_sign_on', 
     'location=0,status=0,scrollbars=0,width=800,height=500'
@@ -45,6 +45,8 @@
         case 'OpenID':
           jQuery('#openid_label').html('{'Please enter your OpenID URL'|translate|escape:javascript}'); break;
-        case 'Wordpress': case 'Flickr': case 'Steam':
+        case 'Wordpress': case 'Steam':
           jQuery('#openid_label').html('{'Please enter your username'|translate|escape:javascript}'); break;
+        case 'Flickr': 
+          jQuery('#openid_label').html('{'Please enter your user ID'|translate|escape:javascript}'); break;
       }
       
@@ -70,5 +72,5 @@
       
     default:
-      open_auth('{$OAUTH.u_login}'+ idp);
+      open_auth(idp);
   }
 });
@@ -93,5 +95,5 @@
   }
 
-  open_auth('{$OAUTH.u_login}OpenID&openid_identifier=' + encodeURI(oi));
+  open_auth('OpenID&openid_identifier=' + encodeURI(oi));
 
   jQuery.colorbox.close();
@@ -111,8 +113,10 @@
 });
 
+{if not empty($OAUTH.persona_email)}
 jQuery('a[href$="act=logout"]').click(function(e) {
   e.preventDefault();
   navigator.id.logout();
 });
+{/if}
 
 navigator.id.watch({
@@ -124,5 +128,8 @@
       url: '{$OAUTH.u_login}Persona',
       dataType: 'json',
-      data: { assertion: assertion },
+      data: {
+        assertion: assertion,
+        key: '{$OAUTH.key}'
+      },
       success: function(data) {
         oauth_redirect(data.redirect_to);
